@echo off
if /i exist "%~nx0" color 40 && echo. && echo. && echo Error^^! Please do not execute this file alone^^! && echo. && echo Please press any key to exit. && pause>nul && exit

:enumerateAdbDevices
    set device_list=
    set serial_number=
    set device_count=0
    set unauthorized_device_count=0
    set /A wait_time=50

    echo.
    echo Note: ADB can only be used after the System is started. ADB is not Fastboot, Fastboot is certainly not ADB.

    echo.
    REM currect adb version
    echo [Debug] Currectly in used adb version:
    %adb% --version

    echo.
    echo Starting ADB Server...

    %adb% start-server
    if %errorlevel% NEQ 0 (
        color fc
        echo.
        echo Fatal Error: Start ADB Server failed^^!
        echo Please check and try to Uninstall all phone assistant or other ROM flash helpers!
        goto :exitEnumeration
    )

    :enumerateAdbLoop
        echo.
        echo Finding ADB device...

        for /F "usebackq tokens=*" %%X in (`%%adb%% devices 2^>^&1 ^| %%awk%% "{print $2}" ^| %%sed%% "/^of$"/d`) do (

            if "%%X" == "device" (
                set /A device_count+=1
            )
            if "%%X" == "unauthorized" (
                set /A device_count+=1
                set /A unauthorized_device_count+=1
            )
        )

        for /F "usebackq tokens=*" %%Y in (`%%adb%% devices 2^>^&1 ^| %%grep%% -i -w "device" ^| %%awk%% "{print $1}"`) do (
            REM get serial number and put to device_list
            echo.
            echo Connected device: [%%Y]
            set device_list=!device_list! %%Y
        )

        REM count wait time
        set /A wait_time-=1

        REM has unauthorized device
        if %unauthorized_device_count% NEQ 0 (
            REM reset device count
            set device_count=0
            set unauthorized_device_count=0
            set device_list=

            echo.
            echo Unauthorized device detected. Please Check the "Always allow from this comuter" option and Click "Allow" button.
            echo If there is a device that does not need to execute ADB commands, please remove it from the computer.
            echo Please perform the operation within !wait_time! seconds.
            ping 127.0.1 -n 2 >nul 2>nul
            if !wait_time! == 0 (
                color fc
                echo.
                echo Fatal Error: You did not allow USB debugging or remove unauthorized devices within the specified time!
                goto :exitEnumeration
            )
            goto :enumerateAdbLoop
        )

        if %device_count% GEQ 2 (
            echo.
            echo Multiple devices have been detected.
            if "!device_list!" == "" (
                ping 127.0.1 -n 2 >nul 2>nul
                if !wait_time! == 0 (
                    color fc
                    echo.
                    echo Fatal Error: A fatal error has occurred, please confirm your operation is correct and try again.
                    goto :exitEnumeration
                )
                goto :enumerateAdbLoop
            )
        ) else (
            if "!device_list!" == "" (
                ping 127.0.1 -n 2 >nul 2>nul
                if !wait_time! == 0 (
                    color fc
                    echo.
                    echo Fatal Error: No device found, please confirm your operation is correct and try again.
                    goto :exitEnumeration
                )
                goto :enumerateAdbLoop
            )

        )
    :: End enumerateAdbLoop

    echo.
    echo Currently %device_count% ADB devices connected: [%device_list%]
    echo.

exit /b 0
::
::
:exitEnumeration
    call "%~dp0killAdbServer.cmd"
    echo.
    echo Press any key to exit.
    pause > nul
exit
