@echo off
if /i exist "%~nx0" color 40 && echo. && echo. && echo Error^^! Please do not execute this file alone^^! && echo. && echo Please press any key to exit. && pause>nul && exit

:menuUnlockBL
@title %title% %version% - Bootloader Unlock Menu
color f9
    echo --------------------------------------------------------------------------------
    echo. [1] Unlock Bootloader for general Android devices ^(flashing unlock^)
    echo. [2] Unlock Bootloader for general Android devices ^(oem unlock, legacy^)
    echo.
    echo. [3] Unlock Bootloader for Motorola devices ^(oem unlock, Unlock code required^)
    echo. [4] Get Device ID ^(get_unlock_data^)
    echo.
    echo. [0] ^<^<^< Return to the Main menu
    echo --------------------------------------------------------------------------------
    set input=
    set /p input= Please enter the option number: ^>^>
        if "%input%"=="1" cls && call :unlockBL1 %input%
        if "%input%"=="2" cls && call :unlockBL1 %input%
        if "%input%"=="3" cls && call :unlockBL2 %input%
        if "%input%"=="4" cls && call :getUnlockData %input%
        if "%input%"=="0" cls && exit /b 0
    cls
goto :menuUnlockBL
::
::
:unlockBL1
@title %title% %version% - Bootloader Unlock Menu ( General Android devices )
color f9
set opts1=%1
    echo ================================================================================
    echo                                          NOTE:
    echo ================================================================================
    echo. [*] This operation will erase all user data, including installed applications, media, files on the internal storage, etc.
    echo. [*] Please enable "OEM unlock" option in Settings -^> System -^> Developer options first, then you can unlock the bootloader.
    echo. [*] After unlocking the Bootloader, it means that you have lost the official warranty, and a warning will be displayed every time you boot.
    echo.
    echo. [*] Please press the volume key, select "UNLOCK THE BOOTLOADER" option, and then press the power button to confirm unlock BL.
    echo --------------------------------------------------------------------------------
    echo.
    echo Please press any key to continue, or click the x button in the upper right corner to exit.
    pause > nul

    call "%~dp0enumerateFbDevices.cmd"

    if "%device_list%" NEQ "" (
        for %%d in (%device_list::= %) do (
            echo.
            echo Processing device: [%%d]
            set serial_number=%%d
            if "!device_count!" == "1" (
                call "%~dp0runUnlockBL.cmd" %opts1%
            ) else (
                start cmd /k call "%~dp0runUnlockBL.cmd" %opts1%
            )

        )
    ) else (
        color fc
        echo.
        echo Fatal Error: Device list not found^^!
        ping 127.0.1 -n 3 >nul 2>nul
        goto :exit
    )

    echo.
    echo Please press any key to return to the Bootloader Unlock menu.
    pause > nul
exit /b 0
::
::
:unlockBL2
@title %title% %version% - Bootloader Unlock Menu ( Motorola devices )
color f9
set opts1=%1
    echo ================================================================================
    echo                                      NOTE:
    echo ================================================================================
    echo. [*] This operation will erase all user data, including installed applications, media, files on the internal storage, etc.
    echo. [*] Please enable "OEM unlock" option in Settings -^> System -^> Developer options first, then you can unlock the bootloader.
    echo. [*] After unlocking the Bootloader, it means that you have lost the official warranty, and a warning will be displayed every time you boot.
    echo --------------------------------------------------------------------------------
    echo.
    echo. [*] Please press the volume key, select "UNLOCK THE BOOTLOADER" option, and then press the power button to confirm unlock BL.

    call "%~dp0enumerateFbDevices.cmd"

    if "%device_list%" NEQ "" (
        for %%d in (%device_list::= %) do (
            echo.
            echo Processing device: [%%d]
            set serial_number=%%d
            if "!device_count!" == "1" (
                call "%~dp0runUnlockBL.cmd" %opts1%
            ) else (
                start cmd /k call "%~dp0runUnlockBL.cmd" %opts1%
            )

        )
    ) else (
        color fc
        echo.
        echo Fatal Error: Device list not found^^!
        ping 127.0.1 -n 3 >nul 2>nul
        goto :exit
    )

    echo.
    echo Please press any key to return to the Bootloader Unlock menu.
    pause > nul

exit /b 0
::
::
:getUnlockData
@title %title% %version% - Bootloader Unlock Menu ( Get Device ID )
color f9
set opts1=%1

    call "%~dp0enumerateFbDevices.cmd"

    if "%device_list%" NEQ "" (
        for %%d in (%device_list::= %) do (
            echo.
            echo Processing device: [%%d]
            set serial_number=%%d
            if "!device_count!" == "1" (
                call "%~dp0runUnlockBL.cmd" %opts1%
            ) else (
                start cmd /k call "%~dp0runUnlockBL.cmd" %opts1%
            )

        )
    ) else (
        color fc
        echo.
        echo Fatal Error: Device list not found^^!
        ping 127.0.1 -n 3 >nul 2>nul
        goto :exit
    )

    :options
        echo --------------------------------------------------------------------------------
        echo Unlocking steps:
        echo. [*] 1. Open Motorola Unlocking the bootloader website, then login Motorola or Google account;
        echo. [*] 2. Enter your Device ID to input box, and click "Can my device be unlocked" button;
        echo. [*] 3. If your device can be unlocked, Click "Request Unlock Key" button.
        echo When finished, unlock code will be sent to your mailbox.
        echo.
        echo. [*] NOTE: some US carriers, Eg. Verizon / AT^&T, can't be unlock Bootloader,
        echo Website will alert you "Your device does not qualify for bootloader unlocking".
        echo.
        echo. [1] Open Motorola Unlocking the bootloader website
        echo. [2] Refetch Device ID
        echo. [3] ^<^< Return to the BootLoader Unlock menu
        echo. [0] ^<^<^< Return to the Main menu
        echo --------------------------------------------------------------------------------
        set input=
        set /p input= Please enter the option number: ^>^>
            if "%input%"=="1" cls && start "" "https://motorola-global-portal.custhelp.com/app/standalone/bootloader/unlock-your-device-b" >nul 2>nul && goto :options
            if "%input%"=="2" cls && goto :getUnlockData
            if "%input%"=="3" cls && exit /b 0 && exit /b 0
            if "%input%"=="0" cls && exit /b 0 && exit /b 0 && exit /b 0
        ping 127.0.1 -n 2 >nul 2>nul
        cls
        goto :options
    exit /b 0

goto :getUnlockData
exit /b 0
::
::
:tips
    echo.
    echo Press any key to exit.
    pause > nul
::
::
:exit
exit
