@echo off
@SETLOCAL enabledelayedexpansion
if /i exist "%~nx0" color 40 && echo. && echo. && echo Error^^! Please do not execute this file alone^^! && echo. && echo Please press any key to exit. && pause>nul && exit

:runAdbAction
color f9
@title %title% %version% - ADB Menu [%serial_number%]
REM vars
set action_option=

    if "%1" == "" (
        color fc
        echo.
        echo Fatal Error: Option is null.
        goto :tips
    ) else (
        set action_option=%1
    )

    if "%action_option%" == "1" call :removeFRP
    if "%action_option%" == "2" call :removeExclamation
    if "%action_option%" == "3" call :setNTPServer

    if %errorlevel% NEQ 0 (
        echo.
        echo Device [%serial_number%] operation failed.
    ) else (
        echo.
        echo Device [%serial_number%] operation is complete.
    )

    if "%device_count%" NEQ "1" (
        goto :tips
    )

exit /b 0
::
::
:removeFRP
@title %title% %version% - Remove Google Factory Reset Protect (FRP) [%serial_number%]

    %adb% -s %serial_number% shell content insert --uri content://settings/secure --bind name:s:user_setup_complete --bind value:s:1
    if %errorlevel% NEQ 0 (
        color f6
        echo.
        echo Error: Opreation failed^^!
        exit /b 1
    )
    color f2
    echo.
    echo If there are no unexpected problems, FRP has been removed. Please reboot the device.
    echo.
    echo Rebooting device...
    %adb% -s %serial_number% reboot

exit /b 0
::
::
:removeExclamation
@title %title% %version% - Remove exclamation on the signal icon [%serial_number%]

    REM get SDK version
    for /F "usebackq tokens=*" %%X in (`%%adb%% -s "%%serial_number%%" shell getprop ro.build.version.sdk 2^>^&1`) do (
        set sdk_version=%%X
    )

    if %sdk_version% GEQ 25 (
        REM if SDK greater or equal to 25
        %adb% -s %serial_number% shell "settings put global captive_portal_http_url http://connectivitycheck.platform.hicloud.com/generate_204"
        %adb% -s %serial_number% shell "settings put global captive_portal_https_url https://connectivitycheck.platform.hicloud.com/generate_204"
        if !errorlevel! NEQ 0 (
            color f6
            echo.
            echo Error: Opreation failed^^!
            exit /b 1
        ) else (
            color f2
            echo.
            echo Remove exclamation finished.
        )
    ) else (
        %adb% -s %serial_number% shell "settings put global captive_portal_server g.cn"
        if !errorlevel! NEQ 0 (
            color f6
            echo.
            echo Error: Opreation failed^^!
            exit /b 1
        ) else (
            color f2
            echo.
            echo Remove exclamation finished.
        )
    )

exit /b 0
::
::
:setNTPServer
@title %title% %version% - Setup China NTP Server [%serial_number%]

    %adb% -s %serial_number% shell "settings put global ntp_server ntp1.aliyun.com"

    REM get ntp_server
    for /F "usebackq tokens=*" %%X in (`%%adb%% -s "%%serial_number%%" shell "settings get global ntp_server" 2^>^&1`) do (
        set ntp_server=%%X
    )

    if "%ntp_server%" == "ntp1.aliyun.com" (
        color f2
        echo.
        echo NTP has been set to: ntp1.aliyun.com.
    ) else (
        color f6
        echo.
        echo Error: NTP setup failed^^!
        exit /b 1
    )

exit /b 0
::
::
:tips
    echo.
    echo Press any key to exit.
    pause > nul
::
::
:exit
exit
