@echo off
@SETLOCAL enabledelayedexpansion
if /i exist "%~nx0" color 40 && echo. && echo. && echo Error^^! Please do not execute this file alone^^! && echo. && echo Please press any key to exit. && pause>nul && exit

:runDIYAction
@title %title% %version% - DIY Menu [%serial_number%]
color f9
REM vars
set diy_option=%1
set partition_name=%2
set image_location=%3

    if "%1" == "" (
        color fc
        echo.
        echo Fatal Error: DIY option is null.
        goto :tips
    )

    if "%2" == "" (
        color fc
        echo.
        echo Fatal Error: Partition name is null.
        goto :tips
    )

    if "%diy_option%" == "1" call :doDIYErase
    if "%diy_option%" == "2" call :doDIYFlash

    if %errorlevel% NEQ 0 (
        echo.
        echo Device [%serial_number%] operation failed.
        echo.
        goto :tips
    ) else (
        color f2
        echo.
        echo Device [%serial_number%] operation is complete.
    )

    if "%device_count%" NEQ "1" (
        goto :tips
    )
exit /b 0
::
::
:doDIYErase
@title %title% %version% - Erase %partition_name% partition [%serial_number%]

    echo.
    echo Executing: fastboot -s %serial_number% erase %partition_name%
    REM Initialize the variable to 0.
    set /A okay_count=0

    for /F "usebackq tokens=*" %%X in (`%%fastboot%% erase %%partition_name%% 2^>^&1`) do (
        echo %%X

        for /F "usebackq tokens=*" %%C in (`echo %%X ^| %%grep%% -i -c "OKAY"`) do (
            if "%%C" == "1" set /A okay_count+=1
        )
    )

    if %okay_count% NEQ 1 (
        color fc
        echo ---------------------------
        echo Error: Erase %partition_name% failed^^!
        echo ---------------------------
        ping 127.0.1 -n 3 >nul 2>nul
        exit /b 1
    )
exit /b 0
::
::
:doDIYFlash
@title %title% %version% - Flash %partition_name% partition [%serial_number%]
    echo.
    echo Executing: fastboot -s %serial_number% flash %partition_name% %image_location%

    REM Initialize the variable to 0.
    set /A okay_count=0
    set /A send_write_count=0

    for /F "usebackq tokens=*" %%X in (`%%fastboot%% -s %%serial_number%% flash %%partition_name%% %%image_location%% 2^>^&1`) do (
        echo %%X
        for /F "usebackq tokens=*" %%C in (`echo %%X ^| %%grep%% -i -c "OKAY"`) do (
            if "%%C" == "1" set /A okay_count+=1
        )
        for /F "usebackq tokens=*" %%C in (`echo %%X ^| %%grep%% -i -c "sending"`) do (
            if "%%C" == "1" set /A send_write_count+=1
        )
        for /F "usebackq tokens=*" %%C in (`echo %%X ^| %%grep%% -i -c "writing"`) do (
            if "%%C" == "1" set /A send_write_count+=1
        )
    )

    if %okay_count% LSS 2 (
        color fc
        echo ---------------------------
        echo Error: fastboot flash %partition_name% failed^^!
        echo ---------------------------
        echo Please check the error message.
        goto :tips
    )

    if %okay_count% NEQ %send_write_count% (
        color fc
        echo ---------------------------
        echo Error: fastboot flash %partition_name%  failed^^!
        echo ---------------------------
        echo Please check the error message.
        goto :tips
    )

exit /b 0
::
::
:tips
    echo.
    echo Press any key to exit.
    pause > nul
::
::
:exit
exit
