@echo off
@SETLOCAL enabledelayedexpansion
if /i exist "%~nx0" color 40 && echo. && echo. && echo Error^^! Please do not execute this file alone^^! && echo. && echo Please press any key to exit. && pause>nul && exit

:runReboot
color f9
@title %title% %version% - Reboot [%serial_number%]
REM vars
set reboot_option=

    if "%1" == "" (
        color fc
        echo.
        echo Fatal Error: Option is null.
        goto :tips
    ) else (
        set reboot_option=%1
    )

    call "%~dp0getPartitionTable.cmd"

    if "%reboot_option%" == "1" call :rebootToSystem
    if "%reboot_option%" == "2" call :rebootToBL
    if "%reboot_option%" == "3" call :rebootToFastbootd

    if %errorlevel% NEQ 0 (
        echo.
        echo Device [%serial_number%] operation failed.
        echo.
        goto :tips
    ) else (
        color f2
        echo.
        echo Device [%serial_number%] operation is complete.
    )

    if "%device_count%" NEQ "1" (
        goto :tips
    )

exit /b 0
::
::
:rebootToSystem
@title %title% %version% - Reboot to System [%serial_number%]
    echo.
    echo ------ Rebooting to System ------
    %fastboot% -s %serial_number% reboot
    if %errorlevel% NEQ 0 (
        color fc
        echo ---------------------------
        echo Error: Reboot failed^^!
        echo ---------------------------
        exit /b 1
    )
exit /b 0
::
::
:rebootToBL
@title %title% %version% - Reboot Bootloader [%serial_number%]
    echo.
    echo ------ Rebooting Bootloader ------
    %fastboot% -s %serial_number% reboot-bootloader
    if %errorlevel% NEQ 0 (
        color fc
        echo ---------------------------
        echo Error: Reboot Bootloader failed^^!
        echo ---------------------------
        exit /b 1
    )
exit /b 0
::
::
:rebootToFastbootd
@title %title% %version% - Reboot Fastbootd mode [%serial_number%]
    echo.
    echo ------ Rebooting to Fastbootd ------
    %fastboot% -s %serial_number% reboot fastboot
    if %errorlevel% NEQ 0 (
        color fc
        echo ---------------------------
        echo Error: Reboot Fastbootd failed^^!
        echo ---------------------------
        exit /b 1
    )
exit /b 0
::
::
:tips
    echo.
    echo Press any key to exit.
    pause > nul
::
::
:exit
exit
