@echo off
@SETLOCAL enabledelayedexpansion
if /i exist "%~nx0" color 40 && echo. && echo. && echo Error^^! Please do not execute this file alone^^! && echo. && echo Please press any key to exit. && pause>nul && exit

:runSmartFlash
color f9
@title %title% %version% - Flash to [%serial_number%]

    if "%1" == "" (
        color fc
        echo.
        echo Fatal Error: Option is null.
        goto :tips
    ) else (
        set flash_option=%1
    )
    if "%2" == "" (
        color fc
        echo.
        echo Fatal Error: Option is null.
        goto :tips
    ) else (
        set file=%2
    )

    REM call "%~dp0getPartitionTable.cmd"

    if "%flash_option%" == "1" call :bootToRecoveryOneTime
    if "%flash_option%" == "2" call :flashToRecoveryPartition
    if "%flash_option%" == "3" call :smartFlashOthers
    if "%flash_option%" == "4" call :flashBootimg

    if %errorlevel% NEQ 0 (
        echo.
        echo Device [%serial_number%] operation failed.
        echo.
        goto :tips
    ) else (
        color f2
        echo.
        echo Device [%serial_number%] operation is complete.
    )

    if "%device_count%" NEQ "1" (
        ping 127.0.1 -n 3 >nul 2>nul
        goto :exit
    )

exit /b 0
::
::
:bootToRecoveryOneTime
@title %title% %version% - Direct booting %file% [%serial_number%]

    echo.
    echo ------ Direct booting Recovery image ------
    %fastboot% -s %serial_number% boot %file%
    if %errorlevel% NEQ 0 (
        color fc
        echo ------------------------------
        echo Error: fastboot booting %file% failed^^!
        echo ------------------------------
        echo.
        echo Please check again.
        echo.
        exit /b 1
    )
    color f2
    echo.
    echo The operation is complete.
    ping 127.0.1 -n 3 >nul 2>nul
exit /b 0
::
::
:flashToRecoveryPartition
@title %title% %version% - Flash Recovery %file% [%serial_number%]

    echo.
    echo ==^> Setting FB mode...
    %fastboot% -s %serial_number% oem fb_mode_set

    echo.
    echo ------ Flashing Recovery image ------
    echo.

    %fastboot% -s %serial_number% flash recovery%slotsuffix% %file%
    if %errorlevel% NEQ 0 (
        color fc
        echo ------------------------------
        echo Error: fastboot flash %file% failed^^!
        echo ------------------------------
        echo.
        echo Please check again.
        echo.
        exit /b 1
    )
    echo.
    echo ==^> Clear FB mode...
    %fastboot% -s %serial_number% oem fb_mode_clear

exit /b 0
::
::
:flashBootimg
@title %title% %version% - Flash Boot %file% [%serial_number%]

    echo.
    echo ==^> Setting FB mode...
    %fastboot% -s %serial_number% oem fb_mode_set

    echo.
    echo ------ Flashing Boot image ------
    echo.

    %fastboot% -s %serial_number% flash boot%slotsuffix% %file%
    if %errorlevel% NEQ 0 (
        color fc
        echo ------------------------------
        echo Error: fastboot flash %file% failed^^!
        echo ------------------------------
        echo.
        echo Please check again.
        echo.
        exit /b 1
    )
    echo.
    echo ==^> Clear FB mode...
    %fastboot% -s %serial_number% oem fb_mode_clear

exit /b 0
::
::
:smartFlashOthers
@title %title% %version% - Flash %file% [%serial_number%]
    echo.
    echo Flashing: %file%
    REM goto true || goto false
    if "%file%" == "gpt.bin" call %fastboot% -s %serial_number% flash partition %file% && goto :sSuccessEnd || goto :sFailEnd
    if "%file%" == "motoboot.img" call %fastboot% -s %serial_number% flash motoboot %file% && goto :sSuccessEnd || goto :sFailEnd
    if "%file%" == "bootloader.img" call %fastboot% -s %serial_number% flash bootloader %file% && goto :sSuccessEnd || goto :sFailEnd
    if "%file%" == "logo.bin" call %fastboot% -s %serial_number% flash logo%slotsuffix% %file% && goto :sSuccessEnd || goto :sFailEnd
    if "%file%" == "logo.img" call %fastboot% -s %serial_number% flash logo%slotsuffix% %file% && goto :sSuccessEnd || goto :sFailEnd
    if "%file%" == "vbmeta.img" call %fastboot% -s %serial_number% flash vbmeta%slotsuffix% %file% && goto :sSuccessEnd || goto :sFailEnd
    if "%file%" == "vbmeta_system.img" call %fastboot% -s %serial_number% flash vbmeta_system%slotsuffix% %file% && goto :sSuccessEnd || goto :sFailEnd
    if "%file%" == "boot.img" call %fastboot% -s %serial_number% flash boot%slotsuffix% %file% && goto :sSuccessEnd || goto :sFailEnd
    if "%file%" == "init_boot.img" call %fastboot% -s %serial_number% flash init_boot%slotsuffix% %file% && goto :sSuccessEnd || goto :sFailEnd
    if "%file%" == "vendor_boot.img" call %fastboot% -s %serial_number% flash vendor_boot%slotsuffix% %file% && goto :sSuccessEnd || goto :sFailEnd
    if "%file%" == "dtb.img" call %fastboot% -s %serial_number% flash dtb%slotsuffix% %file% && goto :sSuccessEnd || goto :sFailEnd
    if "%file%" == "dtbo.img" call %fastboot% -s %serial_number% flash dtbo%slotsuffix% %file% && goto :sSuccessEnd || goto :sFailEnd
    if "%file%" == "adspso.bin" call %fastboot% -s %serial_number% flash dsp%slotsuffix% %file% && goto :sSuccessEnd || goto :sFailEnd
    if "%file%" == "dspso.bin" call %fastboot% -s %serial_number% flash dsp%slotsuffix% %file% && goto :sSuccessEnd || goto :sFailEnd
    if "%file%" == "BTFM.bin" call %fastboot% -s %serial_number% flash bluetooth%slotsuffix% %file% && goto :sSuccessEnd || goto :sFailEnd
    if "%file%" == "radio.img" call %fastboot% -s %serial_number% flash radio %file% && goto :sSuccessEnd || goto :sFailEnd
    if "%file%" == "NON-HLOS.bin" call %fastboot% -s %serial_number% flash modem%slotsuffix% %file% && goto :sSuccessEnd || goto :sFailEnd
    if "%file%" == "fsg.mbn" call %fastboot% -s %serial_number% flash fsg%slotsuffix% %file% && goto :sSuccessEnd || goto :sFailEnd
    if "%file%" == "super.img" call %fastboot% -s %serial_number% flash super %file% && goto :sSuccessEnd || goto :sFailEnd
    if "%file%" == "system.img" call %fastboot% -s %serial_number% flash system%slotsuffix% %file% && goto :sSuccessEnd || goto :sFailEnd
    if "%file%" == "vendor.img" call %fastboot% -s %serial_number% flash vendor%slotsuffix% %file% && goto :sSuccessEnd || goto :sFailEnd
    if "%file%" == "oem.img" call %fastboot% -s %serial_number% flash oem%slotsuffix% %file% && goto :sSuccessEnd || goto :sFailEnd
    if "%file%" == "product.img" call %fastboot% -s %serial_number% flash product%slotsuffix% %file% && goto :sSuccessEnd || goto :sFailEnd

    REM can't match any image
    color f6
    echo.
    echo Warning: Seems %file% not a flashable image file.
exit /b 1
::
::
:sFailEnd
    color fc
    echo ------------------------------
    echo Error: fastboot flash %file% failed^^!
    echo ------------------------------
    echo.
    echo Please check again.
    echo.
exit /b 1

:sSuccessEnd
    echo.
    echo Flash %file% has successeded.
exit /b 0
::
::
:tips
    echo.
    echo Press any key to exit.
    pause > nul
::
::
:exit
exit
